#include "stack.h"
#include <stdlib.h>

int
main(void)
{
    Stack s[2];
    if (Stack__init(&s[0]) != 0) {
        return 1;
    }
    if (Stack__init(&s[1]) != 0) {
        return 1;
    }

    int *p = malloc(sizeof *p);
    //@ assert p == s[0].buffer || p != s[0].buffer;

    //@ assert s[0].count == 0;
    //@ assert s[1].count == 0;
    //@ assert \valid(s[0].buffer);
    //@ assert \valid(s[1].buffer);
    //@ assert \valid(p);

    if (Stack__push(&s[0], 42) != 0) {
        return 1;
    }
    //@ assert s[0].count == 1;
    //@ assert s[1].count == 0;
    //@ assert \valid(s[0].buffer);
    //@ assert \valid(s[1].buffer);
    //@ assert \valid(p);

    int *q = malloc(sizeof *q);
    //@ assert q == s[0].buffer || q != s[0].buffer;
    //@ assert \valid(q);

    int v;
    if (Stack__pop(&s[0], &v) != 0) {
        return 1;
    }
    //@ assert s[0].count == 0;
    //@ assert v == 42;
    //@ assert s[1].count == 0;
    //@ assert \valid(s[0].buffer);
    //@ assert \valid(s[1].buffer);
    //@ assert \valid(p);
    //@ assert \valid(q);


    Stack__final(&s[0]);
    Stack__final(&s[1]);
    return 0;
}
