#include "stack.h"
#include <stdlib.h>
#include <limits.h>

int
Stack__init(Stack *s)
{
    s->capacity = 512;
    s->count = 0;
    if ((s->buffer = malloc(s->capacity * sizeof *s->buffer)) == 0) {
        return -1;
    }
    return 0;
}

void
Stack__final(Stack *s)
{
    free(s->buffer);
}

int
Stack__push(Stack *s, int value)
{
    if (s->capacity == s->count) {
        if (s->capacity >= INT_MAX / 2 / sizeof *s->buffer) {
            return -3;
        }
        int c = s->capacity * 2;
        int *new_buf;
        if ((new_buf = malloc(c * sizeof *s->buffer)) == 0) {
            return 1;
        }
        for (int i = 0; i < s->count; ++i) {
            new_buf[i] = s->buffer[i];
        }
        free(s->buffer);
        s->buffer = new_buf;
        s->capacity = c;
    }
    s->buffer[s->count ++] = value;
    return 0;
}

int
Stack__pop(Stack *s, int *value)
{
    if (s->count == 0) {
        return 1;
    }
    *value = s->buffer[-- s->count];
    return 0;
}
